//----------------------------------------------------------------------
//
// t@C : patterngen.v
// @\       : p^[W[ Verilog
//              16NbN̊ԂɔCӉ񐔃gOM𐶐
// XV   : 2006/11/16 - ver 1.0  
//
// Copyright(C)2006 K.Ochiai. All rights reserved.
//
//----------------------------------------------------------------------
module patterngen(CLK,CKE,RST,TRATE,POUT);
	// o͐M`
	input			CLK;		// NbN
	input			CKE;		// NbNECl[u
	input			RST;		// 񓯊Zbg
	input [7:0]		TRATE;		// gO
	output			POUT;		// p^[o

	// WX^`
	reg [3:0]		counter;	// JE^

	// JE^
	always @(posedge CLK or posedge RST) begin
		if(RST) begin								// 񓯊Zbg
			counter <= 0;
		end else if(CKE) begin						// NbNECl[u'1'̂Ƃȉ̉H삷
			if(counter == 4'b1111) begin
				counter <= 4'b0000;					// őJEgȂNA
			end else
				counter <= counter + 1'b1;			// ȊOȂCNg
		end
	end

	// p^[
	//   JEgƂTRATE̊erbgo͂DJEg̎'0'o͂D
    //   TRATE1rbgEZbg邲ƂɁC16NbÑgO2񑝂D
    //   ăgO0`100܂12.5݂ŉςłD
	function patternsel;
		input [3:0] sel;
		begin
			case(sel)
				0		: patternsel = TRATE[7];
				2		: patternsel = TRATE[6];
				4		: patternsel = TRATE[5];
				6		: patternsel = TRATE[4];
				8		: patternsel = TRATE[3];
				10		: patternsel = TRATE[2];
				12		: patternsel = TRATE[1];
				14		: patternsel = TRATE[0];
				default	: patternsel = 1'b0;
			endcase
		end
	endfunction

	assign POUT = patternsel(counter);

endmodule